#include <avr/interrupt.h>
#include </Users/Jon/Work/technical/peripherals/ambient-attiny/arduino/tessel_amb_module/spi_via_usi_driver.c>

#define MIC      1  //Handy to have in the code to remember what is whay
#define A_IR_RX  7
#define D_IR_RX  9
#define IR_TX   10

#define BUF_SIZE 50

volatile char MIC_BUF[BUF_SIZE];
volatile int  MIC_BUF_LOC=0;
volatile int counter=0;
volatile int CHAN=1;

void setup() {
  // put your setup code here, to run once:
  pinMode(IR_TX,OUTPUT); //IR TX
  pinMode(MIC,INPUT);    //microphone
  pinMode(A_IR_RX,INPUT);//analog IR RX
  pinMode(D_IR_RX,INPUT);//digital IR RX 
  
  // interrupt on INT0 pin falling edge
  MCUCR = (1<<ISC01);

  // turn on interrupts!
  GIMSK  |= (1<<INT0);
  
  DDRB  &= ~(1<<2);
  PORTB |=  (1<<2); 
  
  spiX_initslave(0);
  USICR&= ~(1<<USIOIE);
  USICR&= ~(1<<USIWM0);//Deactivate SPI port interrupts, otherwise it will spi if it sees a clock signal- no good if sharing a DO/DI/CLK lines
  sei();

}




void loop() { //always be putting data in the buffer
  if(MIC_BUF_LOC==BUF_SIZE){
    MIC_BUF_LOC=0;
  }
  if(CHAN!=9){
  MIC_BUF[MIC_BUF_LOC++]=analogRead(CHAN);
  }
  else{
  MIC_BUF[MIC_BUF_LOC++]=digitalRead(CHAN);
  }
}


ISR (INT0_vect, ISR_NOBLOCK){  //nested interrupts, aka stacks on stacks of interrupts.
    USICR|=(1<<USIOIE)|(1<<USIWM0); //re-enable USI
    
    spiX_put(0x55); //ACK
    spiX_wait();
    
    switch(spiX_get()){
      
      case 0x00:     //ACK-ACK signal
      spiX_put(0x55);//ACK
      spiX_wait();
      break;
      
      case 0x01: //READ BUF
      for(counter=0;counter<BUF_SIZE;counter++){//read backwards through the buffer till you get to 0, then start at the buffer end
      spiX_put(MIC_BUF[MIC_BUF_LOC]);
      spiX_wait();
      MIC_BUF_LOC--;
      if(MIC_BUF_LOC<1){
        MIC_BUF_LOC=BUF_SIZE;
      }
      }
      break;
      
      case 0x02: //SET CHAN: ret 0x55 (ACK SUCCESS) or 0xAA (ACK FAIL)
      spiX_put(0x55);//ACK
      spiX_wait();
      CHAN=spiX_get();
      if (CHAN==1 || CHAN==7 ||CHAN==9){
        spiX_put(0x55);//ACK
        spiX_wait();
      }
      else{
        spiX_put(0xAA);//ACK FAIL
        spiX_wait();
        CHAN=1;
      }
      break;
      
      case 0x03://READ CHAN
      spiX_put(CHAN);
      spiX_wait();
      break;     
      
      case 0x04://IR_TX HIGH
      digitalWrite(IR_TX,HIGH);
      spiX_put(0x55);
      spiX_wait();
      break;
      
      case 0x05://IR_TX LOW
      digitalWrite(IR_TX,LOW);
      spiX_put(0x55);
      spiX_wait();
      break;     
      
      
      
    }
    USICR&= ~(1<<USIOIE);  //disable USI
    USICR&= ~(1<<USIWM0);  //disable USI
}

