var util = require('util');
var EventEmitter = require('events').EventEmitter;
var AMBIENT_BUF_SIZE = 50;

var ACK_CMD = 0;
var LIGHT_CMD = 1;
var SOUND_CMD = 2;

var PACKET_CONF = 0x55;
var ACK_CONF = 0x33;

var dummyData = EmptyArray(AMBIENT_BUF_SIZE);

// temp. only here because 'this' is broken
var _ambient;

function Ambient(hardware) {

	// Set the reset pin
	this.reset = hardware.gpio(2);

	// Make sure you fucking pull this high so we don't keep the module reset. 
	this.reset.output().high();

	// Initialize SPI
	this.spi = new hardware.SPI();

	this.lightTriggerLevel = null;

	this.soundTriggerLevel = null;

	// We're going to handle the chip select ourselves for more 
	// sending flexibility
	this.chipSelect = hardware.gpio(1);
	this.chipSelect.output().high();

	_ambient = this;

	// Make sure we can communicate with the module
	this.validateCommunication(function(err) {
		if (err) { 
			throw err;
			return;
		}
		console.log("Communication is established.");

		// temp
		setInterval(function() {
			pollBuffers(_ambient);
		}, 50);
	});

}

// We want the ability to emit events
util.inherits(Ambient, EventEmitter);

// This should really be a class function
// but 'this' isn't working...
var pollBuffers = function(ambient) {

	ambient.chipSelect.low();

	// temporary
	var self = this;

	ambient.validateCommunication(function(err) {
		if (!err) {
			
			ambient.chipSelect.low();
			ambient.spi.transfer(LIGHT_CMD);

			ambient.spi.transfer(dummyData, function(err, response) {
				if (err) {
					console.log("Issue sending dummy data");
					return;
				}

				if (response) ambient.emit('light', response);
				console.log("Light data: ", response);
			});
			ambient.chipSelect.high();

			ambient.chipSelect.low();
			ambient.spi.transfer(SOUND_CMD);

			ambient.spi.transfer(dummyData, function(err, response) {
				if (err) {
					console.log("Issue sending dummy data");
					return;
				}

				if (response) ambient.emit('sound', response);
				console.log("Sound data: ", response);
			});
			ambient.chipSelect.high();
		}
	});
}

function EmptyArray(size) {
	var arr = [];

	for (var i = 0; i < size; i++) {
		arr[i] = 0;
	}

	return arr;
}

Ambient.prototype.validateCommunication = function(callback){

	this.chipSelect.low();
	this.spi.transfer([0x00, 0x00, 0x00], function(err, response) {

		if (err) return callback(err);

		console.log("Validation response: ", response);

		if (response 
			&& (response[0] == PACKET_CONF)
			&& (response[1] == ACK_CMD)
			&& response[2] == ACK_CONF) {
			callback(null);
		} else {
			callback(new Error("Can't connect with module..."));
		}
	});
	this.chipSelect.high();
}	

Ambient.prototype.getLightLevel = function() {

}

Ambient.prototype.setLightTrigger = function(triggerVal) {

}

Ambient.prototype.getSoundLevel = function() {

}

Ambient.prototype.setSoundTrigger = function(triggerVal) {

}


exports.Ambient = Ambient;
exports.connect = function (hardware) {
  	return new Ambient(hardware);
};
